=begin
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
# Designed Nov. 2008 by Fredo6

# Permission to use this software for any purpose and without fee is hereby granted
# Distribution of this software for commercial purpose is subject to:
#  - the expressed, written consent of the author
#  - the inclusion of the present copyright notice in all copies.

# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#-----------------------------------------------------------------------------
# Name			:  Lib6Tool.rb
# Original Date	:  03 Dec 2008 - version 3.0
# Type			:  Script library part of the LibFredo6 shared libraries
# Description	:  Contains some standard interactive tools (selection, pick line, ...)
#-------------------------------------------------------------------------------------------------------------------------------------------------
#*************************************************************************************************
=end

module Traductor

#All Tools
T6[:T_WARNING_InvalidOrigin] = "Invalid Origin" 
T6[:T_WARNING_InvalidTarget] = "Invalid Target" 
T6[:T_STR_Warning] = "WARNING"
T6[:T_STR_Distance] = "Distance"
T6[:T_STR_Coords] = "Coords"
T6[:T_VCB_Steps] = "Step"
T6[:T_VCB_Entities] = "Entities"
T6[:T_VCB_Curves] = "Curves"
T6[:T_VCB_SoftEdges] = "New Edges"
T6[:T_VCB_MakeUnique] = "Make Unique"
T6[:T_VCB_Dicing] = "Slicing"
T6[:T_STR_RedAxis] = "Red axis"
T6[:T_STR_GreenAxis] = "Green axis"
T6[:T_STR_BlueAxis] = "Blue axis"
T6[:T_MNU_Cancel] = "Cancel and Back (ESC)"
T6[:T_MNU_Done] = "Done"
T6[:T_MNU_PropNewEdges] = "Property of newly created edges"

T6[:T_MNU_ArrowUp] = "Arrow Up"
T6[:T_MNU_ArrowLeft] = "Arrow Left"
T6[:T_MNU_ArrowRight] = "Arrow Right"
T6[:T_MNU_ArrowDown] = "Arrow Down"
T6[:T_MNU_Escape] = "Escape"
T6[:T_MNU_BackSpace] = "BackSpace"
T6[:T_MNU_Enter] = "Enter"
T6[:T_MNU_Tab] = "Tab"
T6[:T_MNU_Shift] = "Shift"
T6[:T_MNU_Ctrl] = "Ctrl"
T6[:T_MNU_CtrlShift] = "Ctrl+Shift"
T6[:T_MNU_On] = "On"
T6[:T_MNU_Off] = "Off"
T6[:T_MNU_YES] = "YES"
T6[:T_MNU_NO] = "NO"
T6[:T_MNU_SU_Undo] = "SU Undo, CTRL-Z"
T6[:T_MNU_SU_Redo] = "SU Redo, CTRL-Y"

#Selection Tool
T6[:T_MNU_Selection_Done] = "Done with Selection"
T6[:T_MNU_Selection_Extended] = "Extend selection to connected entities (SHIFT)"
T6[:T_STR_Selection_StatusText] = "Select entities - SHIFT to extend to connected entities"
T6[:T_VCB_Selection_Extended] = "Extended"
T6[:T_VCB_Angle_Slope] = "Angle, Slope"
T6[:T_VCB_Angle] = "Angle"
T6[:T_VCB_Degree] = "Degree"

#PickLine Tool
T6[:T_MSG_PickLine_Origin] = "Click Origin"
T6[:T_MSG_PickLine_Target] = "Click Target - Arrows to force Axis - SHIFT to lock direction"
T6[:T_MSG_Interruptible] = "Click in viewport or Escape to interrupt"

#Dicer
T6[:T_DLG_EdgeProp_Title] = "Properties for New Edges"
T6[:T_DLG_DicerParam_Title] = "Slicing Parameters"
T6[:T_DLG_DicerParam_Nb] = "Number of slices"
T6[:T_DLG_DicerParam_Auto] = "Negative for based on 12-Edge circle"
T6[:T_DLG_DicerParam_SkipStart] = "Skip Start border"
T6[:T_DLG_DicerParam_SkipEnd] = "Skip End border"
T6[:T_DLG_EdgeAdditional] = "Additional Edges:"
T6[:T_DLG_EdgeSoft] = "Soft"
T6[:T_DLG_EdgeSmooth] = "Smooth"
T6[:T_DLG_EdgeHidden] = "Hidden"
T6[:T_DLG_EdgeCastShadows] = "Cast Shadows"
T6[:T_DLG_EdgeDiagonal] = "Diagonal of quads"
T6[:T_DLG_EdgeKeep] = "Keep if Colinear"
T6[:T_DLG_YES] = "YES"
T6[:T_DLG_NO] = "NO"

#inference colors and Tooltip
T6[:T_MNU_Inference_Toggle] = "Toggle Inference Lock"
T6[:T_MNU_Inference_RedAxis] = "Lock Red Axis (ARROW RIGHT)"
T6[:T_MNU_Inference_GreenAxis] = "Lock Green Axis (ARROW LEFT)"
T6[:T_MNU_Inference_BlueAxis] = "Lock Blue Axis (ARROW UP)"
T6[:T_MNU_Inference_NoAxis] = "Release Axis Lock (ARROW DOWN)"
T6[:T_STR_Inference_Blue_Plane] = "Horiz. plane Red/Green"
T6[:T_STR_Inference_Red_Plane] = "Vert. plane Blue/Green"
T6[:T_STR_Inference_Green_Plane] = "Vert. plane Blue/Red"
T6[:T_STR_Inference_Unlock_Plane] = "Unlock plane"
T6[:T_STR_Inference_Colinear_Last] = "Parallel to edge"
T6[:T_STR_Inference_Colinear] = "Collinear to edge"
T6[:T_STR_Inference_Perpendicular] = "Perpendicular to edge"
T6[:T_STR_Inference_Perpendicular_Last] = "Perpendicular to previous"
T6[:T_STR_Inference_45] = "45 degrees"
T6[:T_STR_Inference_45_Last] = "45 degrees to previous"

T6[:T_DEFAULT_InferenceSection] = "Inference for lines"
T6[:T_DEFAULT_InferencePrecision] = "Precision in screen pixels"
T6[:T_DEFAULT_InferenceColor_None] = "Color when NO inference"
T6[:T_DEFAULT_InferenceColor_Collinear] = "Color when line is collinear or parallel"
T6[:T_DEFAULT_InferenceColor_Perpendicular] = "Color when line is perpendicular"
T6[:T_DEFAULT_SectionFunctionKey] = "Function Keys"

T6[:T_MNU_FKeyOn] = "ON"
T6[:T_MNU_FKeyOff] = "OFF"

#--------------------------------------------------------------------------------------------------------------
# Shared Utilities
#--------------------------------------------------------------------------------------------------------------			 

#Create a cursor from a Lib6 file
def Traductor.create_cursor(name, hotx=0, hoty=0)
	MYPLUGIN.create_cursor name, hotx, hoty
end

#Translate Short cuts
@@hsh_shortcuts = nil
def Traductor.translate_shortcut(symb)
	return '' unless symb
	unless @@hsh_shortcuts
		txctrl = T6[:T_KEY_Ctrl] + '-'
		txshift = T6[:T_KEY_Shift] + '-'
		hsh = @@hsh_shortcuts = {}
		hsh[:arrow_up] = T6[:T_MNU_ArrowUp]
		hsh[:arrow_left] = T6[:T_MNU_ArrowLeft]
		hsh[:arrow_right] = T6[:T_MNU_ArrowRight]
		hsh[:arrow_down] = T6[:T_MNU_ArrowDown]
		hsh[:ctrl_arrow_up] = txctrl + T6[:T_MNU_ArrowUp]
		hsh[:ctrl_arrow_left] = txctrl + T6[:T_MNU_ArrowLeft]
		hsh[:ctrl_arrow_right] = txctrl + T6[:T_MNU_ArrowRight]
		hsh[:ctrl_arrow_down] = txctrl + T6[:T_MNU_ArrowDown]
		hsh[:shift_arrow_up] = txshift + T6[:T_MNU_ArrowUp]
		hsh[:shift_arrow_left] = txshift + T6[:T_MNU_ArrowLeft]
		hsh[:shift_arrow_right] = txshift + T6[:T_MNU_ArrowRight]
		hsh[:shift_arrow_down] = txshift + T6[:T_MNU_ArrowDown]
		hsh[:escape] = T6[:T_MNU_Escape]
		hsh[:esc] = T6[:T_MNU_Escape]
		hsh[:backspace] = T6[:T_MNU_BackSpace]
		hsh[:enter] = T6[:T_MNU_Enter]
		hsh[:shift] = T6[:T_MNU_Shift]
		hsh[:ctrl] = T6[:T_MNU_Ctrl]
		hsh[:ctrl_shift] = T6[:T_MNU_CtrlShift]
		hsh[:tab] = T6[:T_MNU_Tab]
		hsh[:on] = T6[:T_MNU_On]
		hsh[:off] = T6[:T_MNU_Off]
		hsh[:yes] = T6[:T_MNU_YES]
		hsh[:no] = T6[:T_MNU_NO]
		hsh[:su_undo] = T6[:T_MNU_SU_Undo]
		hsh[:su_redo] = T6[:T_MNU_SU_Redo]
	end	
	text = @@hsh_shortcuts[symb]
	(text) ? text : symb.to_s
end

#Encode a menu or a tooltip
#If the tip contains a parenthese in last position, then it is assumed to contain the short cut
#if <tab> is passed, then the \t<tab> is appended
def Traductor.encode_menu(text, shortcut=nil, status=nil)
	Traductor.encode_menutip true, text, shortcut, status
end
def Traductor.encode_tip(text, shortcut=nil, status=nil)
	Traductor.encode_menutip false, text, shortcut, status
end

def Traductor.encode_menutip(menu_or_tip, text, shortcut=nil, status=nil)
	if shortcut.class == Array
		ls = shortcut.collect { |s| Traductor.translate_shortcut s }
		shortcut = ls.join ", "
	elsif shortcut	
		shortcut = Traductor.translate_shortcut shortcut
	end	
	if text =~ /(.*)\((.*)\)\Z/
		text = $1
		shortcut = $2 unless shortcut && shortcut.length > 0
	end
	if status == true 
		status = T6[:T_MNU_On]
	elsif status == false	
		status = T6[:T_MNU_Off]
	end	
	text = text + " --> #{status}" if status
	text = text + ((menu_or_tip) ? "\t" + shortcut : ' (' + shortcut + ')') if shortcut
	text
end

#--------------------------------------------------------------------------------------------------------------
# Class TempGroup: Manage temporary groups
#--------------------------------------------------------------------------------------------------------------			 

class TempStuff

def TempStuff.stamp_group(group)
	return unless group && group.valid?
	cdef = group.entities[0].parent
	cdef.name = "___FREDO6_TEMPORARY___#{Time.now.to_f}"
end

#Clean up temporary items that were created in previous sessions
def TempStuff.cleanup
	lerase = []
	model = Sketchup.active_model
	model.definitions.each do |cdef|
		if cdef.name =~ /___FREDO6_TEMPORARY___/
			lerase += cdef.instances
		end
	end	
	return if lerase.empty?
	model.start_operation "LibFredo6 Temporary cleanup"
	lerase.each { |e| e.erase! if e.valid? }
	model.commit_operation
end

end	#class TempStuff

#--------------------------------------------------------------------------------------------------------------
# Class ReturnUp: Utility to manage the Return keyup event after dialog boxes and VCB
#                            inputs (as they can be misinterpreted
#--------------------------------------------------------------------------------------------------------------			 

class ReturnUp

@@return_up = false

def ReturnUp.is_on?
	@@return_up
end

def ReturnUp.set_on
	@@return_up = true
end	

def ReturnUp.set_off
	@@return_up = false
end	

end	#class ReturnUp


#--------------------------------------------------------------------------------------------------------------
# Class AllTools: Common methods to ALL tools 
#--------------------------------------------------------------------------------------------------------------			 

class AllStandardTools

#Method to select the tool as active
def _select
	Sketchup.active_model.select_tool self
end

end	#class AllTools

#--------------------------------------------------------------------------------------------------------------
# Selection Tool for picking up entities
#--------------------------------------------------------------------------------------------------------------			 				   

class StandardSelectionTool < AllStandardTools

#***********************************
# Placeholder for subclassing methods
#***********************************

include MixinCallBack

def sub_initialize(*args) ; end
def sub_cursor_set(entity, extend_selection) ; 0 ; end
def sub_exit_tool ; @model.select_tool nil ; end
def sub_cancel_tool(flag=nil) ; end
def sub_deactivate(view) ; end
def sub_check_entity(entity) ; true ; end
def sub_getMenu_before(menu) ; false ; end
def sub_getMenu_after(menu) ; false ; end
def sub_draw(view) ; end
def sub_get_title_tool() ; "" ; end
def sub_extend_entity(entity, extend_selection, view_hidden) ; nil ; end

#***********************************
# Class Methods
#***********************************

attr_accessor :extend_selection, :extend_face, :keep_selection

#Initialization of the tool
def initialize(caller, *args)
	#Setting the caller
	_register_caller caller

	#Other initializations
	@model = Sketchup.active_model
	@view = @model.active_view
	@extend_selection = false
	@extend_face = false
	@keep_selection = false
	@extended_text = T6[:T_VCB_Selection_Extended]
	@mark_forbidden = G6::DrawMark_Forbidden.new
	@mark_extended = G6::DrawMark_FourArrows.new
	@status_text = T6[:T_STR_Selection_StatusText]
	set_cursor
	
	#Custom initialization
	_sub :initialize, *args
	
	@titletool = _sub :get_title_tool
end

def set_cursor(idcursor=0, sizecursor=24, hotx=0, hoty=0)
	@default_cursor = idcursor
	@sizecursor = sizecursor
	@hotx = hotx
	@hoty = hoty
end

#Activation of the tool
def activate
	@model = Sketchup.active_model
	@selection = @model.selection
	@button_down = false
	validate_pre_selection
	reset_selection
	if @keep_selection
		@stored_entities = @selection.to_a
	else
		#return exit_tool if validate_pre_selection
		return exit_tool if @selection.length > 0
		@selection.clear
	end	
	@rendering_options = @model.rendering_options
	show_info
end

def deactivate(view)
	@x = nil
	_sub :deactivate, view
	view.invalidate
end

#Activation of the tool
def reset_selection
	@icursor = 0
	@ctrl_down = false
	@lst_entities = nil
	@stored_entities = []
	@lst_forbid = []
end

#Validate pre-existing selection if any
def validate_pre_selection
	@lst_entities = nil
	@selection.each do |e| 
		@selection.remove e unless e.class != Sketchup::Drawingelement && _sub(:check_entity, e) 
	end	
	@selection.length > 0
end

#Cancel event
def onCancel(flag, view)
	#User did an Undo
	case flag
	when 1, 2	#Undo or reselect the tool
		activate
		return
	when 0	#user pressed Escape
		reset_selection
		@selection.clear
	end
	_sub :cancel_tool, flag
	view.invalidate
end

#Setting the proper cursor
def onSetCursor
	ic = _sub :cursor_set, @entity, @extend_selection
	UI::set_cursor((ic) ? ic : @default_cursor)
end

#Contextual menu
def getMenu(menu)
	#Custom menu item before 
	return if _sub :getMenu_before, menu
	
	#own menus
	menu.add_item(T6[:T_MNU_Selection_Extended]) { toggle_extend_selection }
	if @selection.length > 0
		menu.add_separator
		menu.add_item(T6[:T_MNU_Selection_Done]) { exit_tool }
	end	

	#Custom menu item after 
	_sub :getMenu_after, menu
	true
end

#Button click - Means that we end the selection
def onLButtonDown(flags, x, y, view)
	@button_down = true
	#execute_action
end

#Button click - Means that we end the selection
def onLButtonUp(flags, x, y, view)
	@button_down = false
	execute_action
end

def toggle_extend_selection
	@extend_selection = ! @extend_selection
	onMouseMove_zero
	#onMouseMove 0, @x, @y, @model.active_view
end

#Trap Modifier keys for extended and Keep selection
def onKeyDown(key, rpt, flags, view)
	key = Traductor.check_key key, flags, false
	case key			
	when CONSTRAIN_MODIFIER_KEY
		toggle_extend_selection

	when COPY_MODIFIER_KEY
		@ctrl_down = true
		onMouseMove_zero unless unselect()
	
	when 13
		Traductor::ReturnUp.set_off

	end	
end

def onKeyUp(key, rpt, flags, view)
	key = Traductor.check_key key, flags, true
	case key			
	when COPY_MODIFIER_KEY
		@ctrl_down = false
	when 13
		execute_action if Traductor::ReturnUp.is_on?
	end	
	show_info
end

#Drawing method - Used to add cursor indicator
def draw(view)
	return unless @x	
	x = @x + @sizecursor - @hotx + 4
	y = @y - @hoty + 4
	if @deny_entity
		@mark_forbidden.draw_at_xy view, x, y
	elsif @extend_selection
		@mark_extended.draw_at_xy view, x, y	
	end	
	_sub :draw, view
end

#Mouse Move method
def onMouseMove_zero
	onMouseMove(0, @x, @y, @view) if @x
end

def onMouseMove(flags, x, y, view)
	return unless x
	@x = x
	@y = y

	#Finding the picked entity
	ph = view.pick_helper
	ph.do_pick x, y
	@entity = ph.best_picked

	manage_selection()
	
	onSetCursor
	view.invalidate
end	

def execute_action
	return if @selection.length == 0
	#return unless @entity
	exit_tool
end

def exit_tool
	@selection.add @lst_entities if @lst_entities
	_sub :exit_tool
end

def manage_selection
	#Highlighting the entities
	@selection.remove(@lst_entities - @stored_entities) if @lst_entities
	
	#Filtering entities
	@deny_entity = false
	@deny_entity = !_sub(:check_entity, @entity) if @entity
	@entity = nil if @deny_entity
	
	#Handling entity, with possible extension
	if @entity
		view_hidden = @rendering_options["DrawHidden"]
		@lst_entities = [@entity]
		
		ls = _sub :extend_entity, @entity, @extend_selection, view_hidden
		@lst_entities |= ls if ls
		if @extend_selection
			unless ls || (@entity.class != Sketchup::Face && @entity.class != Sketchup::Edge)
				@lst_entities |= @entity.all_connected
			end	
		elsif @entity.class == Sketchup::Face && (view_hidden == false || @extend_face)
			@lst_entities |= face_neighbours @entity
		elsif @entity.class == Sketchup::Edge && (curve = @entity.curve)
			@lst_entities |= curve.edges
		end	
		
		@lst_entities = @lst_entities.find_all { |e| _sub(:check_entity, e) }
		
		if (@lst_forbid & @lst_entities).length == 0
			@selection.add @lst_entities
			@lst_forbid = []
		end	
		
		if @ctrl_down
			@stored_entities |= @lst_entities
			@lst_entities = nil
		end
	else
		@lst_forbid = []
	end	
end	

#Unselect a stored selection when CTRL is pressed
def unselect
	return false unless @lst_entities && (@lst_entities & @stored_entities).length > 0 
	@stored_entities = @stored_entities - @lst_entities
	@selection.remove @lst_entities
	@lst_forbid = @lst_entities.clone
	true
end

#Determine all connected faces to the face (i.e. if bording edge is soft or hidden)
#note: the recursive version seems to bugsplat on big number of faces. So I use an iterative version
def face_neighbours(face)
	@hsh_faces = {}
	lface = [face]
	
	while true
		break if lface.length == 0
		f = lface[0]
		if @hsh_faces[f.entityID]
			lface[0..0] = []
			next
		end	
		lface[0..0] = []
		@hsh_faces[f.entityID] = f
		f.edges.each do |e|
			if e.hidden? || e.soft?
				e.faces.each do |ff| 
					lface.push ff unless ff == f || @hsh_faces[ff.entityID]
				end	
			end	
		end
	end	
	@hsh_faces.values
end

def show_info()
	title = @status_text
	title = @titletool + ': ' + title if @titletool && @titletool != ""
	Sketchup.set_status_text title
	label = (@extend_selection) ? @extended_text : ""
	Sketchup.set_status_text label, SB_VCB_LABEL
end

end	#class StandardSelectionTool

#--------------------------------------------------------------------------------------------------------------
# Class StandardPickLineTool: Tool for picking 2 points with inference
#--------------------------------------------------------------------------------------------------------------			 				   
class StandardPickLineTool < AllStandardTools

#***********************************
# Placeholder for subclassing methods
#***********************************

include MixinCallBack

def sub_initialize(*args) ; end
def sub_activate ; end
def sub_deactivate(view) ; end
def sub_cursor_set ; nil ; end
def sub_exit_tool ; @model.select_tool nil ; end
def sub_onCancel(flag, view)  ; nil ; end
def sub_draw_before(view, pt_origin, pt_target) ; true ; end
def sub_draw_after(view, pt_origin, pt_target) ; true ; end
def sub_move(view, pt_origin, pt_target) ; true ; end
def sub_resume(view) ; end
def sub_change_state(state) ; end
def sub_execute(pt_origin, pt_target) ; end
def sub_onLButtonDoubleClick(flags, x, y, view, state) ; end
def sub_getMenu_before(menu) ; false ; end
def sub_getMenu_after(menu) ; false ; end
def sub_test_origin(pt_origin) ; true ; end
def sub_test_target(pt_target) ; true ; end
def sub_get_title_tool() ; "" ; end
def sub_onKeyDown(key, rpt, flags, view) ; false ; end
def sub_onKeyUp(key, rpt, flags, view) ; false ; end

#***********************************
# Class Methods
#***********************************

#Initialization of the tool
def initialize(caller, *args)
	#Setting the caller
	_register_caller caller

	#Initialization
	@model = Sketchup.active_model
	@view = @model.active_view
	@ip1 = Sketchup::InputPoint.new
	@ip2 = Sketchup::InputPoint.new
	@warning_origin = T6[:T_WARNING_InvalidOrigin]
	@warning_target = T6[:T_WARNING_InvalidTarget]
	@mark_forbidden = G6::DrawMark_Forbidden.new 8

	@vec_line = nil
	@normal_plane = nil
	
	@inference = VecInference.new
	
	#Custom initialization
	_sub :initialize, *args
	
	#Title initialization
	@title_tool = _sub :get_title_tool
	title = (@title_tool && @title_tool != "") ? @title_tool + ': ' : ""
	@title_origin = title + T6[:T_MSG_PickLine_Origin]
	@title_target = title + T6[:T_MSG_PickLine_Target]
	@title_distance = T6[:T_STR_Distance]
	@title_warning = T6[:T_STR_Warning]
end

#Activation of the tool
def activate
	@model = Sketchup.active_model
	@selection = @model.selection
	@view = @model.active_view
	@exiting = false
	reset
	_sub :activate
	@view.invalidate
	show_info
	onSetCursor
end

#Set the line style
def set_line_style(width, stipple=nil)
	@inference.set_line_style width, stipple
end

def deactivate(view)
	@exiting = true
	_sub :deactivate, view
	view.invalidate
end

#Resume view after change of view of zoom
def resume(view)
	_sub :resume, view
	view.invalidate
end

#Activation of the tool
def reset
	@icursor = 0
	@state = 0
	@pt_origin = nil
	@pt_target = nil
	@pt_target_proj = nil
	@distance = 0
	@ok_origin = true
	@ok_target = true
	@prev_origin = nil
	@prev_vec = nil
end

#Cancel event
def onCancel(flag, view)
	#User did an Undo
	case flag
	when 1, 2	#Undo or reselect the tool
		_sub :onCancel, flag, view
		exit_tool()
		return
	when 0	#user pressed Escape
		if @state == 0 || (@state >= 1 && @forced_origin)
			_sub :onCancel, flag, view
			exit_tool()
		else
			_sub :move, view, @pt_origin, @pt_origin
			set_state @state - 1
		end	
	end
end

#Setting the proper cursor
def onSetCursor
	idcur = _sub :cursor_set
	UI::set_cursor((idcur) ? idcur : 0)
end

#Restart the tool for a new input
def restart
	@prev_origin = @pt_origin
	if @pt_origin && @pt_target
		@prev_vec = @pt_origin.vector_to @pt_target
	else
		@prev_vec = nil
	end
	set_state 0	
	@model.active_view.invalidate
end

#Control the State of the tool
def set_state(state)
	return if @state == state
	return UI.beep if state == 1 && !@ok_origin
	#return UI.beep if state == 2 && !@ok_target
	@state = state
	if state > 1	
		@state = 2
		_sub :execute, @pt_origin, @pt_target
		return
	end	
	_sub :change_state, @state
	if state <= 1
		@pt_target = nil
	end	
	if state <= 0
		@pt_origin = nil
	end	
	show_info
end

#Contextual menu
def getMenu(menu)
	#Custom menu item before 
	return if _sub :getMenu_before, menu

	@inference.contextual_menu menu

	menu.add_separator
	if @state == 1
		menu.add_item(T6[:T_MNU_Done]) { set_state 2 }
	elsif @state == 0	
		menu.add_item(T6[:T_MNU_Cancel]) { onCancel 0, @model.active_view }
	end	
	
	#Custom menu item before 
	_sub :getMenu_after, menu
	true
end

def lock_axis(axis_code)
	@inference.lock_axis axis_code
end

def set_custom_axes(axes, tooltip=nil)
	@inference.set_custom_axes axes, tooltip
end

def set_origin(pt_origin)
	ptxy = @view.screen_coords pt_origin
	@xdown = ptxy.x
	@ydown = ptxy.y
	@forced_origin = pt_origin
	onMouseMove(0, @xdown, @ydown, @view)
	set_state 1
end

#Set the hash table for entity Ids to avoid when searching for inferences
def set_hsh_entityID(hsh)
	@hsh_entID = hsh
end

def set_mark_origin(lmark, width=2, stipple="")
	@mark_origin = lmark
	@mark_origin_width = width
	@mark_origin_stipple = stipple
end

def set_mark_target(lmark, width=2, stipple="")
	@mark_target = lmark
	@mark_target_width = width
	@mark_target_stipple = stipple
end

#Toggle usage of inference
def toggle_inference
	@flag_inference = !@flag_inference
end

#Button click - Means that we start or end the point selection
def onLButtonDown(flags, x, y, view)
	set_state @state + 1
	@xdown = x
	@ydown = y
end

#Button release - Means that we end or continue the point selection
def onLButtonUp(flags, x, y, view)
	return if @xdown && (@xdown - x).abs < 5 && (@ydown - y).abs < 5
	set_state @state + 1
end

#Recieved a Double click with left mouse button
def onLButtonDoubleClick(flags, x, y, view)
	_sub :onLButtonDoubleClick, flags, x, y, view, @state
end

#Trap Modifier keys for extended and Keep selection
def onKeyDown(key, rpt, flags, view)
	key = Traductor.check_key key, flags, false
	
	#Inference modifiers
	if @inference.handleKeyDown(key, rpt, flags, view)
		onMouseMove_zero
		#onMouseMove 0, @x, @y, view
		return
	end	

	Traductor::ReturnUp.set_off if key == 13

	#Checking other keys
	_sub :onKeyDown, key, rpt, flags, view
end

def onKeyUp(key, rpt, flags, view)
	key = Traductor.check_key key, flags, true
	
	#Inference modifiers
	if @inference.handleKeyUp(key, rpt, flags, view)
		onMouseMove_zero
		return
	end	

	#Other keys
	case key			
	when 13
		set_state @state+1 unless Traductor::ReturnUp.is_on?
	end	
	
	#Checking other keys
	_sub :onKeyUp, key, rpt, flags, view
end

#Mouse Move method
def onMouseMove_zero
	onMouseMove(0, @x, @y, @view) if @x
end

#Move method
def onMouseMove(flags, x, y, view)
	#Synchronize draw and move
	return if @moving
	@moving = true

	return unless x
	@x = x
	@y = y

	#Picking the Origin
	if @state == 0
		@pt_target = nil
		@ip1.pick view, x, y
		@pt_origin = (@forced_origin) ? @inference.force_origin(@forced_origin) : @inference.set_xy_origin(view, x, y)
		@ok_origin = _sub :test_origin, @pt_origin
		validate_origin view
	
	#Picking the target
	elsif @state == 1
		@ip2.pick view, x, y, @ip1
		@inference.set_hsh_entityID @hsh_entID
		@pt_target = @inference.compute_xy_inference view, x, y
		validate_target view	
	end

	view.invalidate
	show_info
	onSetCursor
end	

#Validation of the input for origin
def validate_origin(view)
	@ok_origin = _sub :test_origin, @pt_origin
	if @ok_origin
		@pt_origin = @ok_origin if @ok_origin.class == Geom::Point3d 
		view.tooltip = @ip1.tooltip
		_sub :move, view, @pt_origin, nil
	else
		view.tooltip = @warning_origin
	end	
end

#Validation of the input for target
def validate_target(view, execute=false)
	@ok_target = _sub :test_target, @pt_target
	if @ok_target
		@pt_target = @ok_target if @ok_target.class == Geom::Point3d
		@distance = @pt_origin.distance @pt_target
		view.tooltip = @inference.get_tooltip
		_sub :move, view, @pt_origin, @pt_target
		_sub :execute, @pt_origin, @pt_target if execute
	else
		view.tooltip = @warning_target
	end	
end

#Draw Method
def draw(view)
	@moving = false
	return if @exiting
	
	#Drawing before
	pt_origin = (@state >= 0 && @ok_origin) ? @pt_origin : nil
	pt_target = (@state >= 1 && @ok_target) ? @pt_target : nil
	_sub :draw_before, view, pt_origin, pt_target

	#drawing the input points
	view.line_width = 1
	if @state >= 0
		@ip1.draw view if @state == 0
		@mark_forbidden.draw_at_point3d view, @ip1.position unless @ok_origin
	end
	
	if @state >= 1
		@ip2.draw view if @ip2.position == @pt_target && @inference.no_autoinference
		@mark_forbidden.draw_at_point3d view, @pt_target unless @ok_target
		@inference.draw2d view if @pt_target
	end

	#Drawing after
	_sub :draw_after, view, pt_origin, pt_target
	draw_mark(view, pt_origin, pt_target)	
end

#default drawing for the marks
def draw_mark(view, pt_origin, pt_target)
	if pt_origin && @mark_origin
		view.line_width = @mark_origin_width
		view.line_stipple = @mark_origin_stipple	
		m = @mark_origin
		view.draw_points pt_origin, m[0], m[1], m[2]
	end
	
	if pt_target && @mark_target
		view.line_width = @mark_target_width
		view.line_stipple = @mark_target_stipple		
		m = @mark_target
		view.draw_points pt_target, m[0], m[1], m[2]
	end
end

#Exit the Tool
def exit_tool
	_sub :exit_tool
end

#Standard method to accept text in the VCB
def onUserText(text, view)   
	Traductor::ReturnUp.set_on
	unless @prev_vec
		if @state == 0
			return UI.beep
		elsif @pt_target == nil
			return UI.beep
		end
	end	

	#Imposing the length
	len = Traductor.string_to_length_formula text
	return UI.beep unless len
	
	#Modify current or previous input
	if @state == 0 && @prev_vec
		@pt_origin = @prev_origin
		@pt_target = @pt_origin.offset @prev_vec, len
	else
		vec = @pt_origin.vector_to @pt_target
		@pt_target = @pt_origin.offset vec, len
	end	
	validate_target view, true
end

#Manage the display of the status bar and VCB
def show_info
	if @state == 0
		stext = @title_origin
	else
		stext = @title_target
	end
	
	svalue = ""
	if @distance
		svalue = (@ok_target) ? @distance.to_l : @warning_target
		label = @title_distance
		stext += '  ' + Traductor.format_point(@pt_target) if @pt_target
	elsif !@ok_origin	
		svalue = @warning_origin
		label = @title_warning
	elsif @pt_origin != nil
		stext += '  ' + Traductor.format_point(@pt_origin)	
	else
		label = ""
	end
	
	Sketchup.set_status_text stext
	Sketchup::set_status_text label, SB_VCB_LABEL
	Sketchup::set_status_text svalue, SB_VCB_VALUE		
end

end	#class StandardPickLineTool

#--------------------------------------------------------------------------------------------------------------
# Class VecInference: Manage inference between 2 points
#--------------------------------------------------------------------------------------------------------------			 				   

class VecInference

attr_reader :no_autoinference

Traductor_InferenceType = Struct.new "Traductor_InferenceType", :code, :color, :tooltip

@@hsh_types = nil		#Store parameters for the standard inference types

def initialize
	@ip1 = Sketchup::InputPoint.new
	@ip2 = Sketchup::InputPoint.new
	
	@precision = MYDEFPARAM[:T_DEFAULT_InferencePrecision]
	@color_none = MYDEFPARAM[:T_DEFAULT_InferenceColor_None]
	@color_collinear = MYDEFPARAM[:T_DEFAULT_InferenceColor_Collinear]
	@color_perpendicular = MYDEFPARAM[:T_DEFAULT_InferenceColor_Perpendicular]
	
	build_all_types
		
	@vecdir_forced = nil
	@tooltip = ""
	@x = @y = nil
	@axes_ref = [X_AXIS, Y_AXIS, Z_AXIS]
	@width = 1
	@stipple = ""
end

#Methods to get information
def get_target ; @pt_target ; end
def get_tooltip ; @tooltip ; end

#Build a static list of all Inference types
def build_all_types
	return if @@hsh_types
	@@hsh_types = {}
	build_inference_type '', @color_none, ""
	build_inference_type 'X', 'red', :T_STR_RedAxis
	build_inference_type 'Y', 'green', :T_STR_GreenAxis
	build_inference_type 'Z', 'blue', :T_STR_BlueAxis
	build_inference_type '//', @color_collinear, :T_STR_Inference_Colinear
	build_inference_type 'PP', @color_perpendicular, :T_STR_Inference_Perpendicular
end

def build_inference_type(code, color, symb_tooltip)
	stype = Traductor_InferenceType.new
	stype.code = code
	stype.color = color
	stype.tooltip = T6[symb_tooltip]
	@@hsh_types[code] = stype
end

def set_line_style(width, stipple=nil)
	@width = width.abs if width && width.class == Integer
	@stipple = stipple if stipple && stipple.class == String
end

def set_custom_axes(axes, tooltip=nil)
	if axes
		@axes_ref = axes
		@axes_ttip = tooltip
		@axes_custom = true
	else
		@axes_ref = [X_AXIS, Y_AXIS, Z_AXIS]
		@axes_ttip = nil
		@axes_custom = false
	end	
end

def lock_axis(axis_code)
	case axis_code
	when 'X', 'x'
		set_forced_direction @axes_ref[0], 'X'
	when 'Y', 'y'
		set_forced_direction @axes_ref[1], 'Y'
	when 'Z', 'z'
		set_forced_direction @axes_ref[2], 'Z'
	else
		set_forced_direction nil, ''
	end	
end

#Integrate the menu items related to Inference in the contextual menu
def contextual_menu(menu)
	menu.add_item(T6[:T_MNU_Inference_Toggle]) { toggle_inference }
	menu.add_item(T6[:T_MNU_Inference_RedAxis]) { lock_axis 'X' }
	menu.add_item(T6[:T_MNU_Inference_GreenAxis]) { lock_axis 'Y' }
	menu.add_item(T6[:T_MNU_Inference_BlueAxis]) { lock_axis 'Z' }
	menu.add_item(T6[:T_MNU_Inference_NoAxis]) { lock_axis '' }
end

def set_xy_origin(view, x, y)
	@ip1.pick view, x, y
	set_ip_origin view, @ip1
end

def force_origin(pt_origin)
	@lst_para = []
	@lst_perp = []
	@pt_origin = pt_origin.clone
end

#Set the Origin Input Point
def set_ip_origin(view, ip_origin)
	@ip_origin = ip_origin
	@pt_origin = @ip_origin.position.clone
	
	vertex = @ip_origin.vertex
	edge = @ip_origin.edge
	face = @ip_origin.face
	tr = @ip_origin.transformation
	@lst_para = []
	@lst_perp = []
	if vertex
		@lst_para = vertex.edges.collect { |e| (tr * e.start.position).vector_to(tr * e.end.position) }
		if face
			vnorm = tr * face.normal
			@lst_perp = @lst_para.collect { |v| v * vnorm }
		end	
	elsif edge
		vecedge = (tr * edge.start.position).vector_to(tr * edge.end.position)
		@lst_para = [vecedge]
		@lst_perp = edge.faces.collect { |f| (tr * f.normal) * vecedge }
	end
	@pt_origin
end

def set_target(pt_target)
	@pt_target = pt_target.clone
end

#toggle inference lock	
def toggle_inference
	set_forced_direction((@vecdir_forced) ? nil : @vecdir)
end
	
#Trap Modifier keys for Inference Control
def handleKeyDown(key, rpt, flags, view)
	case key	

	#Shift Key to lock inference
	when CONSTRAIN_MODIFIER_KEY	
		@time_shift = Time.now.to_f
		set_forced_direction((@vecdir_forced) ? nil : @vecdir)

	#Arrow Keys to lock axes	
	when VK_UP
		lock_axis 'Z'
	when VK_RIGHT
		lock_axis 'X'
	when VK_LEFT
		lock_axis 'Y'
	when VK_DOWN
		lock_axis ''
			
	#Ignore all other keys	
	else
		return false
	end	
	
	return true
end

def handleKeyUp(key, rpt, flags, view)
	case key			
	when CONSTRAIN_MODIFIER_KEY		#Shift Key
		set_forced_direction nil if (Time.now.to_f - @time_shift) > 0.6
	else
		return false
	end	
	
	return true
end
	
#Set a forced reference direction	
def set_forced_direction(vecdir, code=nil)
	if vecdir && vecdir.valid?
		@vecdir_forced = vecdir
		@vecdir = vecdir
		@code = code if code
	else
		@vecdir_forced = nil
	end	
end
	
def prepare_directions
	lst = []
	
	#Model Axes
	lst.push [@axes_ref[0], "X"] if @axes_ref[0]
	lst.push [@axes_ref[1], "Y"] if @axes_ref[1]
	lst.push [@axes_ref[2], "Z"] if @axes_ref[2]
	
	#Parallel and Perpendicular to edges at origin
	@lst_para.each { |vec| lst.push [vec, "//"] if vec.valid? }
	@lst_perp.each { |vec| lst.push [vec, "PP"] if vec.valid? }
	
	#returning the list
	lst
end
	
def set_hsh_entityID(hsh)
	@hsh_entID = hsh
end
	
def compute_xy_inference(view, x, y)
	@ip2.pick view, x, y, @ip1
	@x = x
	@y = y
	compute_inference view, @ip2
	@pt_target
end

def compute_ip_inference(view, ip_target)
	compute_inference view, ip_target
	@pt_target
end

def guess_ip_position(view, pt_origin, ip, x, y, hsh_entID)
	dof = ip.degrees_of_freedom
	no_autoinference = ((dof == 0 && ip.vertex) || (dof == 1 && ip.edge)) && 
	                     G6.not_auto_inference?(ip, hsh_entID)
	return ip.position if no_autoinference
	pt2d = view.screen_coords pt_origin
	ray = view.pickray pt2d.x, pt2d.y
	ray2 = view.pickray x, y
	pt = Geom.intersect_line_plane ray2, [pt_origin, ray[1]]
	(pt) ? pt : ip.position
end

# Top method to compute the direction infered by the target point
def compute_inference(view, ip_target)
	@ip_target = ip_target
	@dof = @ip_target.degrees_of_freedom
	pt = @ip_target.position
	#pt = guess_ip_position view, @pt_origin, @ip_target, @x, @y, @hsh_entID
	@tooltip = @ip_target.tooltip	
	@color = @color_none
	@pt_target = pt.clone
	@no_autoinference = false
	
	#Inference forced 
	return close_to_vector(view, pt, @vecdir_forced, @code) if @vecdir_forced
			
	#Testing if the direction is valid
	vecdir = @pt_origin.vector_to pt
	return unless vecdir.valid?
	@vecdir = vecdir
	
	#Inference along particular directions
	prepare_directions.each { |ldir| return if close_to_vector view, pt, ldir[0], ldir[1] }
	
	#Degree of freedom constrained
	@no_autoinference = ((@dof == 0 && @ip_target.vertex) || (@dof == 1 && @ip_target.edge)) && 
	                     G6.not_auto_inference?(@ip_target, @hsh_entID)
	#return if @no_autoinference

	#No inference
	@code = ""
end

def true_inference_vertex?(view, ip)
	vertex = ip.vertex
	return false unless vertex
	pt2d = view.screen_coords vertex.position
	return false if (pt2d.x - @x).abs > 10 || (pt2d.y - @y).abs > 10
	[/from/i, /von/i, /de/i].each do |pat|
		return false if ip.tooltip && ip.tooltip =~ pat
	end		
	true
end

#Trigger inference if the direction is close to a given reference vector
def close_to_vector(view, pt, vecref, code)
	#Compute the real point if possible
	pt = @ip_target.position
	vertex = @ip_target.vertex
	edge = @ip_target.edge
	face = @ip_target.face
	tr = @ip_target.transformation
	if @vecdir_forced == nil && (vertex || edge || face)
		vecdir = @pt_origin.vector_to pt
		ps = vecdir.normalize % vecref.normalize
		return false if ps.abs < 0.996
		@pt_target = pt.project_to_line [@pt_origin, vecref]
		@vecdir = @pt_origin.vector_to @pt_target

	elsif @vecdir_forced && @x && G6.true_inference_vertex?(view, @ip_target, @x, @y)
		ptproj = pt.project_to_line [@pt_origin, @vecdir_forced]
		@pt_target = ptproj
		@vecdir = @pt_origin.vector_to @pt_target
		
	#Checking proximity based on screen coordinates
	else					
		p1 = view.screen_coords @pt_origin
		p2 = view.screen_coords @pt_origin.offset(vecref, 1)
		vref2d = p1.vector_to p2
		p3 = view.screen_coords pt
		pproj = p3.project_to_line [p1, vref2d]
		return false unless @vecdir_forced || p3.distance(pproj) <= @precision
		ray = view.pickray pproj.x, pproj.y
		lpt = Geom.closest_points [@pt_origin, vecref], ray
		@pt_target = lpt[0]
		@vecdir = vecref
	end	
	
	#Computing tooltip and color
	code = @code unless code
	stype = @@hsh_types[code]
	if stype
		@code = code.upcase
		@color = stype.color
		@tooltip = stype.tooltip
		@tooltip += ' (' + @axes_ttip + ')' if @axes_custom && @axes_ttip && ['X', 'Y', 'Z'].include?(code)
	end	
	true
end

#Draw the line between the origin and target
def draw2d(view, ref_width=nil, stipple=nil)
	draw_23d true, view, ref_width, stipple
end
def draw(view, ref_width=nil, stipple=nil)
	draw_23d false, view, ref_width, stipple
end

def draw_23d(flag_2d, view, ref_width=nil, stipple=nil)
	return if @width == 0
	return unless @pt_origin && @pt_target
	
	#Drawing the line between origin and target
	view.drawing_color = @color
	view.line_stipple = (stipple) ? stipple : @stipple
	width = (ref_width) ? ref_width : @width
	view.line_width = (@vecdir_forced) ? 2 * width : width
	if flag_2d
		view.draw2d GL_LINE_STRIP, view.screen_coords(@pt_origin), view.screen_coords(@pt_target)
	else
		view.draw GL_LINE_STRIP, @pt_origin, @pt_target
	end	
	
	#Drawing the reference perpendicular if required
	if @code == "PP"
		vpp = @lst_para.find { |v| (@vecdir % v).abs <= 0.001 }
		if vpp
			p1 = view.screen_coords @pt_origin
			p2 = view.screen_coords @pt_origin.offset(vpp, 10)
			v2d = p1.vector_to p2
			pa = p1.offset v2d, 30
			pb = p1.offset v2d, -30
			view.line_stipple = ""
			view.line_width = 4
			view.drawing_color = @color
			view.draw2d GL_LINE_STRIP, pa, pb
		end	
	end
end

end	#class VecInference

#--------------------------------------------------------------------------------------------------------------
# Class ColorLine: Manage some utilities for colors
#--------------------------------------------------------------------------------------------------------------			 				   

class Couleur

#compute color based on a vector
def Couleur.color_vector(vec, colordef=nil, face=nil)
	colordef = "black" unless colordef
	if (vec == nil || vec.length == 0)
		color = colordef
	elsif (vec.parallel? X_AXIS)
		color = "red"
	elsif (vec.parallel? Y_AXIS)
		color = "green"
	elsif (vec.parallel? Z_AXIS)
		color = "blue"
	else
		color = colordef
	end
	
	return Couleur.color_at_face(color, face)		
end

#Compute the color based on vector and face, possibly changing the color so that it can be seen
def Couleur.color_at_face(color, face)	
	return color unless face && face.valid?
	view = Sketchup.active_model.active_view
	material = (view.camera.direction % face.normal <= 0) ? face.material : face.back_material
	return color unless material
	Couleur.revert_color color, material.color
end

def Couleur.revert_color(color, face_color)	
	color = Sketchup::Color.new(color) unless color.kind_of?(Sketchup::Color)
	face_color = Sketchup::Color.new(face_color) unless face_color.kind_of?(Sketchup::Color)
	return color if Couleur.contrasted_enough?(color.to_a, face_color.to_a)
	Sketchup::Color.new(255 - color.red, 255 - color.green, 255 - color.blue)
end

def Couleur.contrasted_enough?(rgb1, rgb2)
	sum = 0
	for i in 0..2
		sum += [rgb1[i], rgb2[i]].max - [rgb1[i], rgb2[i]].min
	end
	sum > 400
end

end	# class Couleur

#--------------------------------------------------------------------------------------------------------------
# Class ContextMenu: management of contextual menu
#--------------------------------------------------------------------------------------------------------------			 				   

class ContextMenu

#Initialize the Contextual menu
def initialize
	@list_cmd = []
end

#Indicate separator to contextual menu
def add_sepa
	@list_cmd.push nil
end

#Indicate a function key contribution to contextual menu
def add_fkey(fkey, flag)
	@list_cmd.push fkey.create_cmd(flag) if condition
end

#Indicate a Sketchup command to contextual menu
def add_cmd(cmd)
	@list_cmd.push cmd
end

def add_item(text, shortcut=nil, status=nil, &proc)
	text = Traductor.encode_menu text, shortcut, status
	#####add_cmd UI::Command.new(text) { proc.call }
	add_cmd [text, proc] if proc
end

#Show the contextual menu
def show(menu)
	return if @list_cmd.length == 0
	sepa = nil
	@list_cmd.pop until @list_cmd.last || @list_cmd.length == 0
	@list_cmd.each do |cmd|
		if cmd && cmd[0]
			menu.add_item(cmd[0]) { cmd[1].call }
		elsif sepa
			menu.add_separator
		end
		sepa = cmd
	end
end

end	#class ContextMenu

#========================================================================================
#========================================================================================
# Please Wait tool
#========================================================================================
#========================================================================================

class PleaseWaitTool

def initialize(ruby, color=nil)
	@ruby = ruby
	@started = false
	@novisual = !G6.su_capa_refresh_view
	
	@model = Sketchup.active_model
	@view = @model.active_view
	w = @view.vpwidth
	h = 16
	@rect = []
	@rect.push Geom::Point3d.new(0, 0)
	@rect.push Geom::Point3d.new(0, h)
	@rect.push Geom::Point3d.new(w, h)
	@rect.push Geom::Point3d.new(w, 0)
	@pt_text = Geom::Point3d.new 10, 0, 0
	@color = color
	@color = "yellow" unless color	
end

#Display a message
def message(message, color=nil)
	@message = message
	@color = color
	unless @started
		Sketchup.active_model.tools.push_tool self
		@started = true
	end	
	Sketchup.set_status_text @message
	@view.refresh unless @novisual
end

def exit
	return unless @started
	Sketchup.active_model.tools.pop_tool
	@started = nil
end

def activate
	LibFredo6.register_ruby @ruby if @ruby
	@view.refresh unless @novisual
end

def deactivate(view)
	@message = nil
	@view.refresh
end

def draw(view)
	return unless @message
	view.line_width = 1
	view.line_stipple = ""
	view.drawing_color = 'blue'
	view.draw GL_LINE_LOOP, @rect
	view.drawing_color = @color
	view.draw2d GL_POLYGON, @rect
	view.draw_text @pt_text, @message
end

end	#class PleaseWaitTool

#========================================================================================
#========================================================================================
# Class HourGlass: HourGlass management
#========================================================================================
#========================================================================================

class HourGlass

@@hourglass = nil

#Built-in Hourclass
def HourGlass.start(delay=0.2) ; @@hourglass = HourGlass.new :red unless @@hourglass ; @@hourglass.start delay ; end
def HourGlass.stop ; @@hourglass.stop if @@hourglass ; end
def HourGlass.check? ; (@@hourglass) ? @@hourglass.check? : false ; end


#Instance Initialization
def initialize(symb_color=nil, message=nil)
	@message = (message) ? message : T6[:T_STR_PleaseWait]
	compute_cursor symb_color
	@symb_color = symb_color
	@active = false
end

def compute_cursor(symb_color)
	case symb_color
	when :red
		@id_cursor_red = Traductor.create_cursor "Cursor_HourGlass_Red", 16, 16 unless @id_cursor_red
		@id_cursor = @id_cursor_red
	when :blue
		@id_cursor_blue = Traductor.create_cursor "Cursor_HourGlass_Blue", 16, 16 unless @id_cursor_blue
		@id_cursor = @id_cursor_blue
	else
		@id_cursor_green = Traductor.create_cursor "Cursor_HourGlass_Green", 16, 16 unless @id_cursor_green
		@id_cursor = @id_cursor_green
	end	
end

def start(delay=0.2)
	@time_start = Time.now
	@delay = delay
	@active = false
end

def check?
	if !@active && Time.now - @time_start > @delay
		@active = true
		UI.set_cursor @id_cursor
		Sketchup.set_status_text @message if @message
	end
	@active
end

def stop
	@time_start = Time.now
	@active = false
	Sketchup.set_status_text "" if @message
	UI.set_cursor 0
end

end	#class HourGlass

#========================================================================================
#========================================================================================
# Class VisualProgressBar: Visual Progress bar management with slider
#========================================================================================
#========================================================================================

class VisualProgressBar

#VBAR: Initialization - Creation of instance
def initialize(title, *hargs)
	@title = title
	@title0 = title
	parse_options *hargs
	@novisual = !G6.su_capa_refresh_view
	@time_start = nil
	@view = Sketchup.active_model.active_view
	@message = false
	@retina_factor = Traductor.retina_factor
	
	@hsh_bottoms = {}
	@hsh_bottoms[:interruptible] = T6[:T_MSG_Interruptible]
	@nbchar = 70
	
	init_colors
	
	compute_visual_elements
	
	set_bottom_message @msg_symb
end

#VBAR: Initialize the color styles
def init_colors
	case @style_color
	when :bluegreen
		@bk_color = 'lightyellow'
		@slider_color = 'lightgreen'
		@mini_color = 'blue'
		@title_color = 'lightblue'
		@title_frcolor = 'gray'
	else
		@bk_color = 'lightyellow'
		@slider_color = 'orange'
		@mini_color = 'goldenrod'
		@title_color = 'khaki'
		@title_frcolor = 'gray'
	end
end

#VBAR: Parse the options
def parse_options(*hargs)
	hargs.each do |harg|
		next unless harg.class == Hash
		harg.each do |key, value|
			case key.to_s
			when /style_color/i
				@style_color = value
			when /mini_delay/i
				@mini_delay = value
			when /delay/i
				@delay = value
			when /interrupt/i
				@msg_symb = :interruptible
			end	
		end
	end
end

#VBAR: Compute the position of the elements
def compute_visual_elements
	return if @novisual
	box_w = 500
	pc_margin = 70
	bx_margin = 10
	tx_margin = 20
	@sli_w = box_w - pc_margin - bx_margin
	sli_h = 30
	box_h = 4 * bx_margin + 2 * tx_margin + sli_h
	@mini_w = 150
	mini_h = 10
		
	#Main box
	vpx = @view.vpwidth
	vpy = @view.vpheight
	xbox = (vpx - box_w) * 0.5
	ybox = (vpy - box_h) * 0.5
	@main_box = G6.pts_rectangle xbox, ybox, box_w, box_h

	#Additional message box
	h = 24
	@msg_box = G6.pts_rectangle xbox, ybox+box_h, box_w, h
	@pt_msg = Geom::Point3d.new xbox + 20, ybox+box_h + 3
	
	#Slider box
	xsli = xbox + bx_margin
	ysli = ybox + 2 * bx_margin + tx_margin
	@slider_frame = G6.pts_rectangle xsli, ysli, @sli_w, sli_h
	@slider_box = G6.pts_rectangle xsli, ysli, @sli_w, sli_h
	
	#Title position
	xtit = xbox + 0.5 * box_w
	ytit = ybox + bx_margin
	@pt_title0 = Geom::Point3d.new xtit, ytit, 0
	@pt_title = @pt_title0.clone

	#Message position
	xtext = xbox + bx_margin
	ytext = ybox + box_h - bx_margin - tx_margin
	@pt_text = Geom::Point3d.new xtext, ytext, 0

	#Mini Slider
	xmini = xbox + bx_margin + @sli_w - @mini_w
	ymini = ytext + 3
	@mini_frame = G6.pts_rectangle(xmini, ymini, @mini_w, mini_h)
	@mini_box = G6.pts_rectangle(xmini, ymini, @mini_w, mini_h)
	
	#Percent position
	xpc = xsli + 0.5 * @sli_w 
	ypc = ysli + 0.5 * (sli_h - tx_margin)
	@pt_percent = Geom::Point3d.new(xpc, ypc, 0)

	#Time position
	xtime = xsli + @sli_w + bx_margin
	ytime = ysli + 0.5 * (sli_h - tx_margin)
	@pt_time = Geom::Point3d.new(xtime, ytime, 0)
	
	#Retina Transformation
	if @retina_factor != 1
		t = @tretina = Geom::Transformation.scaling(@view.center, @retina_factor)
		@sli_w *= @retina_factor
		@mini_w *= @retina_factor
		@main_box = @main_box.collect { |pt| t * pt }
		@msg_box = @msg_box.collect { |pt| t * pt }
		@slider_frame = @slider_frame.collect { |pt| t * pt }
		@slider_box = @slider_box.collect { |pt| t * pt }
		@mini_frame = @mini_frame.collect { |pt| t * pt }
		@mini_box = @mini_box.collect { |pt| t * pt }
		@pt_msg = t * @pt_msg
		@pt_title0 = t * @pt_title0
		@pt_title = t * @pt_title
		@pt_text = t * @pt_text
		@pt_percent = t * @pt_percent
		@pt_time = t * @pt_time
		@t_title = Geom::Transformation.scaling(@pt_title0, @retina_factor)
		@xtra_width = @retina_factor.round
	else
		#@tretina = @title = nil
		@xtra_width = 1
	end
	
end

#VBAR: Set or unset a bottom message
def set_bottom_message(symb_or_text=nil)
	if symb_or_text.class == Symbol
		@msg_bottom = @hsh_bottoms[symb_or_text]
		@msg_bottom = symb_or_text.to_s unless @msg_bottom
	elsif symb_or_text.class == String
		@msg_bottom = symb_or_text
	else
		@msg_bottom = nil
	end	
end

#VBAR: Start the visual progression
def start(message=nil)
	Hilitor.declare_active self
	@time_start = @time_prev = @time_last_refresh = Time.now
	@timelog = []
	@hsh_timelog = Hash.new(0)
	@dashed = '|' + '-' * @nbchar + '|'
	@arrow_pos = 1
	@message = message if message
end

#VBAR: Stop the visual progression
def stop(log=false)
	return unless @time_start
	progression 1.0
	@duration = Time.now - @time_start
	@time_start = nil
	Sketchup.set_status_text T6[:T_TIP_Time, sprintf("%4.2f", @duration)]
	Hilitor.declare_inactive self
	
	print if log

	@duration
end

def print
	return unless @timelog
	title = (@title0) ? @title0 : @title
	s = "**************************************************************"
	puts "\n#{s}"
	puts "#{title}: TOTAL Duration = #{@duration}"
	puts s
	@timelog.each do |a|
		puts "#{a[0..1].inspect}"
	end	
	puts s
	@hsh_timelog.each do |key, a|
		key = "Other tasks" unless key
		puts "#{key} --> #{sprintf("%2.3f", a)} s"
	end	
	puts "#{title}: TOTAL Duration = #{@duration} s"
	puts s
end

def print_summary(text=nil)
	return unless @timelog
	text = "" unless text
	title = (@title0) ? @title0 : @title
	s = "**************************************************************"
	puts "\n#{s}"
	puts "#{title}: #{text}"
	puts s
	@hsh_timelog.each do |key, a|
		key = "Other tasks" unless key
		puts "#{key} --> #{sprintf("%2.3f", a)} s"
	end	
	puts "#{title}: TOTAL Duration = #{@duration} s"
	puts s
end

def get_timelog ; @timelog ; end
def get_hsh_timelog ; @hsh_timelog ; end

#VBAR: Trigger a progression in the visual bar
def progression(ratio, message=nil)
	return unless @time_start
	@extra_message = nil
	if message != @message
		t0 = Time.now
		dt = t0 - @time_prev
		@timelog.push [@message, dt, t0 - @time_start] if @message
		@hsh_timelog[@message] += dt
		@message = message if message
		@time_prev = t0
	end	
	@ratio = @ratio0 = ratio
	@mini_ratio = nil
	process_progression
end

#VBAR: Trigger a mini progression in the visual bar
def mini_progression(mini_ratio, out_of=nil, extra_message=:no)
	return unless @time_start
	return unless mini_ratio && @ratio
	return if @mini_delay && (Time.now - @time_prev) < @mini_delay
	out_of = 1.0 unless out_of
	@mini_ratio = mini_ratio
	@extra_message = extra_message unless extra_message == :no
	@ratio = @ratio0 + mini_ratio * out_of
	process_progression
end

#VBAR: Process the update of the visual bar
def process_progression
	dt = Time.now - @time_start
	@tx_dt = sprintf("%0.2f", dt) + ' s'
	@tx_pc = "#{(@ratio * 100).round}%"
	show_text
	if !@novisual && (!@delay || dt >= @delay)
		@time_last_refresh = Time.now
		@view.refresh
	end	
end

def update_time(extra_message=nil)
	@extra_message = extra_message
	return unless @time_start
	process_progression
end

#VBAR: Set or change the title
def update_message(message)
	@message = message
	return unless @time_start
	process_progression
end

#VBAR: Set or change the title
def update_title(title)
	@title = title
end

#VBAR: Drawing routine to be called by the tool
def draw(view)
	return false unless @time_start && @ratio
	return false if @novisual
	
	#Drawing the main box
	view.line_width = 3 * @xtra_width
	view.line_stipple = ''
	view.drawing_color = @bk_color
	view.draw2d GL_POLYGON, @main_box
	view.drawing_color = 'blue'
	view.draw2d GL_LINE_LOOP, @main_box
	
	#Draw the message box
	if @msg_bottom
		view.line_width = 3 * @xtra_width
		view.line_stipple = ''
		view.drawing_color = 'yellow'
		view.draw2d GL_POLYGON, @msg_box
		view.drawing_color = 'blue'
		view.draw2d GL_LINE_LOOP, @msg_box
		view.draw_text @pt_msg, @msg_bottom
	end
	
	#Drawing the slider
	len = @ratio * @sli_w
	@slider_box[1].x = @slider_box[2].x = @slider_box[0].x + len
	view.drawing_color = @slider_color
	view.draw2d GL_POLYGON, @slider_box

	#Drawing the slider box
	view.line_width = 2 * @xtra_width
	view.drawing_color = 'black'
	view.draw2d GL_LINE_LOOP, @slider_frame
	
	#Drawing the minibox if applicable
	if @mini_ratio
		len = @mini_ratio * @mini_w
		@mini_box[1].x = @mini_box[2].x = @mini_box[0].x + len
		view.drawing_color = @mini_color
		view.draw2d GL_POLYGON, @mini_box
		view.line_width = 1 * @xtra_width
		view.drawing_color = 'black'
		view.draw2d GL_LINE_LOOP, @mini_frame
	end
	
	#Drawing the texts
	if @message
		txt = @message
		txt += " - #{@extra_message}" if @extra_message
		view.draw_text @pt_text, txt
	end	
	view.draw_text @pt_percent, @tx_pc
	view.draw_text @pt_time, @tx_dt
	
	#Drawing the title
	if @title && @title.length > 0
		w, = G6.simple_text_size(@title)
		@pt_title.x = @pt_title0.x - 0.5 * w
		pts = G6.pts_rectangle @pt_title.x - 5, @pt_title.y, w + 2 * 5, 20
		pts = pts.collect { |pt| @t_title * pt } if @t_title
		view.line_width = 2 * @xtra_width
		view.drawing_color = @title_color
		view.draw2d GL_POLYGON, pts
		view.drawing_color = @title_frcolor
		view.draw2d GL_LINE_LOOP, pts
		view.draw_text @pt_title, @title
	end	
	true
end

#VBAR: Updating the status bar
def show_text
	#Building the text
	text = ""
	if @message && @message.length > 0
		text = "  #{@message}" 
		text += "  - #{@extra_message}" if @extra_message
	end
	
	ipos = [(@nbchar * @ratio).round, @nbchar].min
	@dashed[@arrow_pos, 1] = '-' if @arrow_pos > 0
	@arrow_pos = ipos + 1
	@dashed[@arrow_pos, 1] = '>' if @arrow_pos > 0
	
	#Updating the status bar
	Sketchup.set_status_text @dashed + text
	Sketchup.set_status_text @tx_pc, SB_VCB_LABEL
	Sketchup.set_status_text @tx_dt, SB_VCB_VALUE
end

end	#class VisualProgressBar

#========================================================================================
#========================================================================================
# Class Hilitor: Visual elements
#========================================================================================
#========================================================================================

class Hilitor

@@lst_active_visuals = [] unless defined?(@@lst_active_visuals) && !@@lst_active_visuals.empty?

#Class methods to handle list of hilitors, visual bars and visual panels
def Hilitor.declare_active(hiob)
	@@lst_active_visuals.delete hiob
	@@lst_active_visuals.push hiob
end

def Hilitor.declare_inactive(hiob)
	@@lst_active_visuals.delete hiob
end

def Hilitor.draw_all_active(view)
	status = false
	@@lst_active_visuals.each { |hiob| status |= hiob.draw(view) }
	status
end

def Hilitor.stop_all_active
	@@lst_active_visuals.each { |hiob| hiob.stop }
end

end	#class Hilitor

#========================================================================================
#========================================================================================
# Class VisualPanel: Visual message
#========================================================================================
#========================================================================================

class VisualPanel

#VPANEL: Initialization - Creation of instance
def initialize(title, *hargs)
	@title = title
	@delay = 0.3
	@mini_delay = 0.5
	parse_options *hargs
	@novisual = !G6.su_capa_refresh_view
	@time_start = nil
	@view = Sketchup.active_model.active_view
	@retina_factor = Traductor.retina_factor
	@message = false
	
	init_colors
	
	compute_visual_elements
end

#VPANEL: Initialize the color styles
def init_colors
	case @style_color
	when :bluegreen
		@bk_color = 'lightyellow'
		@title_color = 'lightblue'
		@title_frcolor = 'gray'
	else
		@bk_color = 'lightgreen'
		@title_color = 'lightblue'
		@title_frcolor = 'gray'
	end
end

#VPANEL: Parse the options
def parse_options(*hargs)
	hargs.each do |harg|
		next unless harg.class == Hash
		harg.each do |key, value|
			case key.to_s
			when /style_color/i
				@style_color = value
			when /mini_delay/i
				@mini_delay = value
			when /delay/i
				@delay = value
			end	
		end
	end
end

#VPANEL: Compute the position of the elements
def compute_visual_elements
	return if @novisual
	box_w = 500
	pc_margin = 70
	bx_margin = 10
	tx_margin = 20
	box_h = 4 * bx_margin + 2 * tx_margin
		
	#Main box
	vpx = @view.vpwidth
	vpy = @view.vpheight
	xbox = (vpx - box_w) * 0.5
	ybox = (vpy - box_h) * 0.5
	@main_box = G6.pts_rectangle xbox, ybox, box_w, box_h
		
	#Title position
	xtit = xbox + 0.5 * box_w
	ytit = ybox + bx_margin
	@pt_title0 = Geom::Point3d.new xtit, ytit, 0
	@pt_title = @pt_title0.clone

	#Message position
	xtext = xbox + bx_margin
	ytext = ybox + box_h - bx_margin - tx_margin
	@pt_text = Geom::Point3d.new xtext, ytext, 0

	#Time position
	xtime = xbox + bx_margin + box_w - pc_margin
	ytime = ytext
	@pt_time = Geom::Point3d.new xtime, ytime, 0

	if @retina_factor != 1
		t = @tretina = Geom::Transformation.scaling(@view.center, @retina_factor)
		@main_box = @main_box.collect { |pt| t * pt }
		@pt_title0 = t * @pt_title0
		@pt_title = t * @pt_title
		@pt_text = t * @pt_text
		@pt_time = t * @pt_time
		@t_title = Geom::Transformation.scaling(@pt_title0, @retina_factor)
		@xtra_width = @retina_factor.round
	else
		#@tretina = @title = nil
		@xtra_width = 1
	end	
end

#VPANEL: Start the visual progression
def start(message=nil)
	Hilitor.declare_active self
	@time_start = @time_prev = Time.now
	@time_last_refresh = nil
	@message = message if message
end

#VPANEL: Stop the visual progression
def stop
	return unless @time_start
	duration = Time.now - @time_start
	@time_start = nil
	Sketchup.set_status_text "#{duration}"
	@view.refresh unless @novisual
	Hilitor.declare_inactive self
	duration
end

#VPANEL: Trigger a progression in the visual bar
def progression(message=nil)
	return unless @time_start
	@extra_message = nil
	if message != @message
		@message = message if message
		@time_prev = Time.now
	end	
	process_progression
end

#VPANEL: Process the update of the visual bar
def process_progression
	dt = Time.now - @time_start
	@tx_dt = sprintf("%0.2f", dt) + ' s'
	return if @mini_delay && @time_last_refresh && (Time.now - @time_last_refresh) < @mini_delay
	show_text
	return if @novisual
	if (!@delay || dt >= @delay)
		@time_last_refresh = Time.now
		@view.refresh
	end	
end

#VPANEL: Just update the time, with an extra message optionally
def update_time(extra_message=nil)
	return unless @time_start
	@extra_message = extra_message
	process_progression
end

#VPANEL: Drawing routine to be called by the tool
def draw(view)
	return false unless @time_start
	return false if @novisual
	
	#Drawing the main box
	view.line_width = 3 * @xtra_width
	view.line_stipple = ''
	view.drawing_color = @bk_color
	view.draw2d GL_POLYGON, @main_box
	view.drawing_color = 'blue'
	view.draw2d GL_LINE_LOOP, @main_box
		
	#Drawing the texts
	if @message
		txt = @message
		txt += " - #{@extra_message}" if @extra_message
		view.draw_text @pt_text, txt
	end	
	view.draw_text @pt_time, @tx_dt
	
	#Drawing the title
	if @title && @title.length > 0
		w, = G6.simple_text_size(@title)
		@pt_title.x = @pt_title0.x - 0.5 * w
		pts = G6.pts_rectangle @pt_title.x - 5, @pt_title.y, w + 2 * 5, 20
		pts = pts.collect { |pt| @t_title * pt } if @t_title
		view.line_width = 2 * @xtra_width
		view.drawing_color = @title_color
		view.draw2d GL_POLYGON, pts
		view.drawing_color = @title_frcolor
		view.draw2d GL_LINE_LOOP, pts
		view.draw_text @pt_title, @title
	end	
	true
end

#VPANEL: Updating the status bar
def show_text
	#Building the text
	text = ""
	if @message && @message.length > 0
		text = "  #{@message}" 
		text += "  - #{@extra_message}" if @extra_message
	end
	
	#Updating the status bar
	Sketchup.set_status_text text
	Sketchup.set_status_text @tx_dt, SB_VCB_VALUE
end

end	#class VisualPanel

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
#  Zoom simulation on wireframe
#----------------------------------------------------------------------------
#----------------------------------------------------------------------------

class ZoomArtefact
	
def initialize
	@model = Sketchup.active_model
	@view = @model.active_view
end
	
def create_mark(pt, style=nil)
	if style == :cube
		@pixels = 1
		size = @view.pixels_to_model @pixels, pt
		v = X_AXIS + Y_AXIS + Z_AXIS
		pt0 = ORIGIN.offset v, size
		pt1 = ORIGIN.offset v.reverse, size
		bb = Geom::BoundingBox.new.add pt0, pt1
		corners = [[0, 4, 6, 2], [1, 5, 7, 3], [0, 1, 5, 4], [2, 3, 7, 6], [0, 1, 3, 2], [4, 5, 7, 6]]
		corners.each do |corner|
			face = @zoom_group.entities.add_face corner.collect { |i| bb.corner(i) }
			face.material = face.back_material = 'red'
		end	
	else
		@pixels = 2
		size = @view.pixels_to_model @pixels, pt
		pt2 = ORIGIN.offset X_AXIS, size
		@zoom_edge = @zoom_group.entities.add_edges ORIGIN, pt2
	end
	
	@zoom_pt = ORIGIN
end
	
#Move the mark - Create it if not done already	
def move_mark(pt)
	return unless pt
	#Creating the small edge if it does not exist
	entities = @model.active_entities
	unless @zoom_group && @zoom_group.valid?
		@zoom_group = entities.add_group
		@zoom_group.hidden = true
		create_mark pt, :cube
		@zoom_pt = ORIGIN
		TempStuff.stamp_group @zoom_group
		return
	end
	
	#Resizing the group if necessary	
	size = @view.pixels_to_model(@pixels, pt) * 0.5
	leng = @zoom_group.bounds.diagonal
	center = @zoom_group.bounds.center
	ts = Geom::Transformation.scaling center, size / leng
	
	#Moving the construction point
	@zoom_pt = pt
	tt = Geom::Transformation.translation center.vector_to(pt)
	entities.transform_entities tt * ts, [@zoom_group]
	@zoom_group.hidden = false
end
	
#Erase the fake mark
def terminate
	@zoom_group.erase! if @zoom_group && @zoom_group.valid?
	@zoom_group = nil
end
	
def get_pos_screen
	return nil unless @zoom_group
	ptxy = @view.screen_coords @zoom_group.bounds.center
	[ptxy.x, ptxy.y]
end
	
def visibility(on=true)
	if @zoom_group && @zoom_group.valid?
		@zoom_group.visible = on
	end	
end
	
def ZoomArtefact.cleanup
	lerase = []
	model = Sketchup.active_model
	model.definitions.each do |cdef|
		if cdef.name =~ /___ZOOM_ARTEFACT/
			lerase += cdef.instances
		end
	end	
	return if lerase.empty?
	model.start_operation "LibFredo6 Zoom artefact cleanup"
	lerase.each { |e| e.erase! if e.valid? }
	model.commit_operation
end
	
end	#End class ZoomArtefact

#========================================================================================
#========================================================================================
# Temporary Layer Management
#========================================================================================
#========================================================================================

class TemporaryLayer

@@layer_name = "LIBFREDO6_TEMP_LAYER"

def initialize
	@model = Sketchup.active_model
	@layers = @model.layers
	store_current_layers
	@temp_layer = @layers.add @@layer_name
end

def store_current_layers
	@old_active_layer_id = @model.active_layer.name
	@hsh_visible_layers = {}
	@model.layers.each do |layer|
		@hsh_visible_layers[layer.name] = layer.visible?
	end	 
end

#Return the SU layer
def layer
	@layers.add @@layer_name
end

#Switch to the temporary layer and hide all other layers
def switch_to_temp_layer
	@temp_layer = @layers.add @@layer_name
	@model.active_layer = @temp_layer
	@layers.each do |layer|
		layer.visible = false unless layer == @temp_layer
	end	 
	@temp_layer.visible = true
end

#Switch back to normal
def restore
	@temp_layer = @layers.find { |layer| layer.name == @@layer_name }
	return unless @temp_layer
	old_active_layer = @model.layers.find { |layer| layer.name == @old_active_layer_id }
	@model.active_layer = old_active_layer
	@model.layers.each do |layer|
		layer.visible = @hsh_visible_layers[layer.name]
	end	 
	@temp_layer.visible = false if @temp_layer.valid?
end

#Delete the temp layer and possibly the entities on this layer
def erase(flg_objects=true)
	
end

end	#class TemporaryLayer

#========================================================================================
#========================================================================================
# Temporary Layer Management
#========================================================================================
#========================================================================================

class KeyManager

#Initialization
def initialize(*hargs, &proc)
	@call_proc = proc
	reset
	set_param(*hargs)
end

#Reset all flags
def reset
	@shift_down = @ctrl_down = @alt_down = false
	reset_num
end

def reset_num
	@num_shiftdown = @num_ctrldown = @num_altdown = 0
end

#Set parameters
def set_param(*hargs)
	hargs.each { |arg| arg.each { |key, value|  parse_args(key, value) } if arg.class == Hash }
end

#Parse the arguments of the initialize method
def parse_args(key, value)
	skey = key.to_s
	case skey
	when /suops/i
		@suops = value
	end	
end	

def call_event(event)
	@call_proc.call(event, @key, @view) if @call_proc
end

#Query for modifiers keys
def shift_down? ; @shift_down ; end
def ctrl_down? ; @ctrl_down ; end
def alt_down? ; @alt_down ; end

#KEY: Handle Key down
def onKeyDown(key, rpt, flags, view)
	key = Traductor.new_check_key key, flags, false
	@key = key
	@view = view
	
	#Interrupting geometry construction if running
	ret_val = false
	if @suops && @suops.interrupt?
		return ret_val
	end	
		
	#Passthrough key down
	return false if call_event(:down) == :stop
	
	@num_shiftdown += 1
	@num_ctrldown += 1
	@num_altdown += 1
	case key			
	when CONSTRAIN_MODIFIER_KEY
		@shift_down = @num_shiftdown
		call_event :shift_down
		@time_shift_down = Time.now
		
	when COPY_MODIFIER_KEY
		@protractor_mode_at_down = @protractor_mode
		@ctrl_down = @num_ctrldown
		call_event :ctrl_down
		@time_ctrl_down = Time.now
	
	when ALT_MODIFIER_KEY
		@alt_down = @num_altdown
		call_event :alt_down
		@time_alt_down = Time.now
		ret_val = true

	when VK_DELETE
		call_event :delete_down
		ret_val = true
				
	when VK_UP, VK_DOWN, VK_RIGHT, VK_LEFT
		call_event :arrow_down
		
	else
		if key == 8	#backspace
			call_event :backspace
		else	
			call_event :other_down
		end	
		reset_num
		##Traductor::VCBDialog.display(key) { |text| onUserText(text, @view) }
		return ret_val
	end	
	ret_val
end

#KEY: Key UP received
def onKeyUp(key, rpt, flags, view)
	key = Traductor.new_check_key key, flags, true
	@key = key
	@view = view
	
	#Passthrough key down
	return false if call_event(:up) == :stop
	
	#Dispatching the event
	ret_val = false
	case key		
	
	when CONSTRAIN_MODIFIER_KEY
		if @shift_down && @shift_down == @num_shiftdown && @time_shift_down && (Time.now - @time_shift_down) < 0.4
			@shift_down = false
			call_event :shift_toggle
		else	
			@shift_down = false
			call_event :shift_up
		end	
		
	when COPY_MODIFIER_KEY
		if @ctrl_down && @ctrl_down == @num_ctrldown && @time_ctrl_down && (Time.now - @time_ctrl_down) < 0.4
			@ctrl_down = false
			call_event :ctrl_toggle
		else	
			@ctrl_down = false
			call_event :ctrl_up
		end	

	when ALT_MODIFIER_KEY
		if @alt_down && @alt_down == @num_altdown && @time_alt_down && (Time.now - @time_alt_down) < 0.4
			@alt_down = false
			call_event :alt_toggle
		else	
			@alt_down = false
			call_event :alt_up
		end	
		ret_val = true
		
	when VK_DELETE
		call_event :delete_up
		ret_val = true
				
	when VK_UP, VK_DOWN, VK_RIGHT, VK_LEFT
		call_event :arrow_up
		
	else 
		if @time_ctrl_down && (Time.now - @time_ctrl_down) < 0.4
			call_event :ctrl_other_up
		elsif @time_shift_down && (Time.now - @time_shift_down) < 0.4
			call_event :shift_other_up
		elsif @time_alt_down && (Time.now - @time_alt_down) < 0.4
			call_event :alt_other_up
		end	
		if key == 9			#TAB
			call_event((@shift_down) ? :shift_tab : :tab)
			return ret_val
		else
			call_event :other_up
			return ret_val
		end
		reset
	end	
	ret_val
end
	
end	#class KeyManager

end #Module Traductor

